#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
import __builtin__
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from prewikka import env
from prewikka.utils import nameToPath
from prewikka.templates.TopLayout import TopLayout

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.1'
__CHEETAH_versionTuple__ = (2, 4, 1, 'final', 0)
__CHEETAH_genTime__ = 1438954268.873189
__CHEETAH_genTimestamp__ = 'Fri Aug  7 15:31:08 2015'
__CHEETAH_src__ = 'prewikka/templates/ClassicLayout.tmpl'
__CHEETAH_srcLastModified__ = 'Fri Aug  7 15:31:02 2015'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class ClassicLayout(TopLayout):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(ClassicLayout, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def body_class(self, **KWS):



        ## CHEETAH: generated from #def body_class() at line 5, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''classic_body
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def toplayout_content(self, **KWS):



        ## CHEETAH: generated from #block toplayout_content at line 9, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _orig_filter_77164795 = _filter
        filterName = u'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write(u'''<script type="text/javascript">

function check_same_origin(url) {
    /*
     * Force url.hostname to be defined in IE9
     * (problem with dynamically created links)
     */
    if ( ! url.hostname )
        url.href = url.href;

    /*
     * When the default port is used in IE9,
     * location.port is empty but url.port is not
     */
    default_port = {"http:": "80", "https:": "443"};
    return url.protocol == location.protocol && url.hostname == location.hostname && (url.port || default_port[url.protocol]) == (location.port || default_port[location.protocol]);
}

$(document).ready(function() {
        prewikka_loadTab({url: "''')
        _v = VFFSL(SL,"document.fullhref",True) # u'$document.fullhref' on line 30, col 33
        if _v is not None: write(_filter(_v, rawExpr=u'$document.fullhref')) # from line 30, col 33.
        write(u'''", data: "''')
        _v = VFFSL(SL,"document.query_string",True) # u'$document.query_string' on line 30, col 61
        if _v is not None: write(_filter(_v, rawExpr=u'$document.query_string')) # from line 30, col 61.
        write(u'''", type: "''')
        _v = VFFSL(SL,"document.request_method",True) # u'$document.request_method' on line 30, col 93
        if _v is not None: write(_filter(_v, rawExpr=u'$document.request_method')) # from line 30, col 93.
        write(u'''"});

        /*
         * Back/Forward support.
         */
        $(window).on("popstate", function(e) {
                if ( e.originalEvent.state == null )
                        return;

                prewikka_loadTab({url: e.originalEvent.state, history:false});
        });

        $(document).on("click", "a, area", function(event) {
                var url = $(this).attr(\'href\');

                if ( ! url || url.indexOf("#") != -1 )
                        return;

                if ( ! check_same_origin(this) ) {
                        window.open(url, "''')
        _v = VFFSL(SL,"env.external_link_target",True) # u'$env.external_link_target' on line 49, col 43
        if _v is not None: write(_filter(_v, rawExpr=u'$env.external_link_target')) # from line 49, col 43.
        write(u'''");
                        return false;
                }

                if ( ! $(this).hasClass("widget-link") )
                        prewikka_loadTab({ url: url });
                else
                        prewikka_widget({ url: url, dialog: { title: $(this).attr(\'title\') }});

                return false;
        });

        $(document).on("click", ":input.widget-link", function() {
                prewikka_widget({
                        url: $(this).closest("form").attr("action"),
                        dialog: { title: $(this).attr("title") }
                });

                return false;
        });

        $(document).on("submit", "#main form", function() {
                $(this).find("input[name=_download]").remove();

                var data = $(this).serialize();

                if ( $(this).data("clicked") ) {
                        data += "&" + $(this).data("clicked");
                        $(this).removeData("clicked");
                }

                if ( $(this).data("enable-download") ) {
                        $(this).removeData("enable-download");
                        $(this).append(\'<input type="hidden" name="_download" value="true" />\');

                        /* No AJAX for download */
                        return true;
                }

                prewikka_loadTab({
                        url: $(this).attr("action"),
                        type: $(this).attr("method"),
                        data: data
                });

                return false;
        });

        $(document).on("click", "#main form input[type=submit]", function() {
                var name = $(this).attr("name");
                var value = $(this).attr("value");

                if ( name && value )
                        $(this).closest("form").data("clicked", encodeURIComponent(name) + "=" + encodeURIComponent(value));
        });
});
</script>

<div id="topmenu">
''')
        for section in VFN(VFFSL(SL,"interface.sections",True),"keys",False)(): # generated from line 108, col 2
            style = ""
            if VFFSL(SL,"section",True) != VFFSL(SL,"interface.active_section",True): # generated from line 110, col 3
                style = "display:none;"
            write(u'''
  <div style="padding: 0px; margin: 0px; ''')
            _v = VFFSL(SL,"style",True) # u'$style' on line 114, col 42
            if _v is not None: write(_filter(_v, rawExpr=u'$style')) # from line 114, col 42.
            write(u'''" class="topmenu_section" id="topmenu_''')
            _v = VFFSL(SL,"nameToPath",False)(VFFSL(SL,"section",True)) # u'$nameToPath($section)' on line 114, col 86
            if _v is not None: write(_filter(_v, rawExpr=u'$nameToPath($section)')) # from line 114, col 86.
            write(u'''">
''')
            for name, views in VFN(VFN(VFFSL(SL,"interface.sections",True),"get",False)(VFFSL(SL,"section",True)),"items",False)(): # generated from line 115, col 3
                firstview = VFN(VFFSL(SL,"views",True),"values",False)()[0]
                if VFFSL(SL,"prewikka.user",True) and not VFN(VFFSL(SL,"prewikka.user",True),"has",False)(VFFSL(SL,"firstview.view_permissions",True)): # generated from line 117, col 5
                    continue
                write(u'''
''')
                if VFFSL(SL,"name",True) == VFFSL(SL,"interface.active_tab",True): # generated from line 121, col 5
                    class_ = 'topmenu_item_active'
                else: # generated from line 123, col 5
                    class_ = ''
                write(u'''
    <div class="topmenu_item ''')
                _v = VFFSL(SL,"class_",True) # u'$class_' on line 127, col 30
                if _v is not None: write(_filter(_v, rawExpr=u'$class_')) # from line 127, col 30.
                write(u'''"><p><a href="''')
                _v = VFFSL(SL,"firstview.view_path",True) # u'$firstview.view_path' on line 127, col 51
                if _v is not None: write(_filter(_v, rawExpr=u'$firstview.view_path')) # from line 127, col 51.
                write(u'''" class="topmenu_links">''')
                if False:
                    _(VFFSL(SL,"name",True))
                _v = VFFSL(SL,"_",False)(VFFSL(SL,"name",True)) # u'$_($name)' on line 127, col 95
                if _v is not None: write(_filter(_v, rawExpr=u'$_($name)')) # from line 127, col 95.
                write(u'''</a></p></div>
''')
            write(u'''  </div>
''')
        write(u'''
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_77164795
        write(u'''
  <div class="topmenu_item_special">
  <button type="button" id="help-button" title="''')
        if False:
            _("Help")
        _v = VFFSL(SL,"_",False)("Help") # u'$_("Help")' on line 135, col 49
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Help")')) # from line 135, col 49.
        write(u'''"></button>
  <button type="button" id="maximize-button" title="''')
        if False:
            _("Maximize")
        _v = VFFSL(SL,"_",False)("Maximize") # u'$_("Maximize")' on line 136, col 53
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Maximize")')) # from line 136, col 53.
        write(u'''"></button>
''')
        if VFFSL(SL,"prewikka.logout_link",True): # generated from line 137, col 3
            write(u'''  <button type="button" id="logout-button" title="''')
            if False:
                _("Logout")
            _v = VFFSL(SL,"_",False)("Logout") # u'$_("Logout")' on line 138, col 51
            if _v is not None: write(_filter(_v, rawExpr=u'$_("Logout")')) # from line 138, col 51.
            write(u'''" onclick="location.href=\'''')
            _v = VFFSL(SL,"document.base_url",True) # u'${document.base_url}' on line 138, col 89
            if _v is not None: write(_filter(_v, rawExpr=u'${document.base_url}')) # from line 138, col 89.
            _v = VFFSL(SL,"prewikka.logout_link",True) # u'$prewikka.logout_link' on line 138, col 109
            if _v is not None: write(_filter(_v, rawExpr=u'$prewikka.logout_link')) # from line 138, col 109.
            write(u'''\'"></button>
''')
        write(u'''  </div>

  <div class="topmenu_item_user">
''')
        lnk = VFFSL(SL,"document.base_url",True) + "usersettingsdisplay"
        if VFFSL(SL,"varExists",False)("prewikka.user.name"): # generated from line 144, col 5
            write(u'''     ''')
            if False:
                _('%s account')
            title = VFFSL(SL,"_",False)('%s account') % VFFSL(SL,"prewikka.user.name",True)
            write(u'''     <p><b><a class="widget-link" title="''')
            _v = VFFSL(SL,"title",True) # u'$title' on line 146, col 42
            if _v is not None: write(_filter(_v, rawExpr=u'$title')) # from line 146, col 42.
            write(u'''" href="''')
            _v = VFFSL(SL,"lnk",True) # u'$lnk' on line 146, col 56
            if _v is not None: write(_filter(_v, rawExpr=u'$lnk')) # from line 146, col 56.
            write(u'''">''')
            _v = VFFSL(SL,"prewikka.user_display",True) # u'$prewikka.user_display' on line 146, col 62
            if _v is not None: write(_filter(_v, rawExpr=u'$prewikka.user_display')) # from line 146, col 62.
            write(u'''</a></b></p>
''')
        write(u'''  </div>
''')
        _orig_filter_59614549 = _filter
        filterName = u'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write(u'''
</div>
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_59614549
        write(u'''
''')
        _orig_filter_64173021 = _filter
        filterName = u'Filter'
        if self._CHEETAH__filters.has_key("Filter"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write(u'''
<script type="text/javascript">
$(document).ready(function() {
  $("#maximize-button").click(function() {
\t$("#top_view").toggleClass("maximized");
  });

  $("span.menu_item_delimiter").on("click", function() {
    $(this).nextUntil("span").slideToggle();
    $(this).siblings("span.menu_item_delimiter").nextUntil("span").slideUp();
  });

  $("a.menu_item_active").prevAll("span.menu_item_delimiter").first().click();

});

</script>

''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_64173021
        write(u'''
''')
        _orig_filter_65952955 = _filter
        filterName = u'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write(u'''<div id="menu">
''')
        style = ''
        for name, tabs in VFN(VFFSL(SL,"interface.sections",True),"items",False)(): # generated from line 178, col 3
            if VFFSL(SL,"name",True) == VFFSL(SL,"interface.active_section",True): # generated from line 179, col 5
                class_ = 'menu_item_active'
            else: # generated from line 181, col 5
                class_ = 'menu_item_inactive'
            write(u'''
''')
            link = ""
            for tab, views in VFN(VFFSL(SL,"tabs",True),"items",False)(): # generated from line 186, col 5
                firstview = VFN(VFFSL(SL,"views",True),"values",False)()[0]
                if VFFSL(SL,"prewikka.user",True) and not VFN(VFFSL(SL,"prewikka.user",True),"has",False)(VFFSL(SL,"firstview.view_permissions",True)): # generated from line 188, col 9
                    continue
                write(u'''
''')
                link = VFFSL(SL,"firstview.view_path",True)
                break
            write(u'''
''')
            if not VFFSL(SL,"tabs",True): # generated from line 196, col 5
                #  Display a delimiter if the section has no tabs
                write(u'''      <span class="menu_item_delimiter">''')
                if False:
                    _(VFFSL(SL,"name",True))
                _v = VFFSL(SL,"_",False)(VFFSL(SL,"name",True)) # u'$_($name)' on line 198, col 41
                if _v is not None: write(_filter(_v, rawExpr=u'$_($name)')) # from line 198, col 41.
                write(u'''</span>
''')
                style = 'display:none;'
            elif VFFSL(SL,"link",True): # generated from line 200, col 5
                #  Display a clickable section if an accessible tab was found
                write(u'''      <a class="menu_item menu_item_''')
                _v = VFFSL(SL,"nameToPath",False)(name) # u'$nameToPath(name)' on line 202, col 37
                if _v is not None: write(_filter(_v, rawExpr=u'$nameToPath(name)')) # from line 202, col 37.
                write(u''' ''')
                _v = VFFSL(SL,"class_",True) # u'$class_' on line 202, col 55
                if _v is not None: write(_filter(_v, rawExpr=u'$class_')) # from line 202, col 55.
                write(u'''" href="''')
                _v = VFFSL(SL,"link",True) # u'$link' on line 202, col 70
                if _v is not None: write(_filter(_v, rawExpr=u'$link')) # from line 202, col 70.
                write(u'''" style="''')
                _v = VFFSL(SL,"style",True) # u'$style' on line 202, col 84
                if _v is not None: write(_filter(_v, rawExpr=u'$style')) # from line 202, col 84.
                write(u'''">''')
                if False:
                    _(VFFSL(SL,"name",True))
                _v = VFFSL(SL,"_",False)(VFFSL(SL,"name",True)) # u'$_($name)' on line 202, col 92
                if _v is not None: write(_filter(_v, rawExpr=u'$_($name)')) # from line 202, col 92.
                write(u'''</a>
''')
                # else
                #  Do not display the section, the user miss the necessary permissions
        write(u'''
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_65952955
        write(u'''
<span>
''')
        #  Empty span for section (un)folding
        write(u'''</span>

</div>
<div id="_main_viewport"></div>
<div id="_main">
 <div id="ajax-spinner" class="ajax-spinner" style="display:none;">
  <img id="img-spinner" src="prewikka/images/ajax-loader.gif" alt="Loading"/>
 </div>
 <div id="main" class="content" />
</div>

''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''

''')
        self.toplayout_content(trans=trans)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_ClassicLayout= 'writeBody'

## END CLASS DEFINITION

if not hasattr(ClassicLayout, '_initCheetahAttributes'):
    templateAPIClass = getattr(ClassicLayout, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(ClassicLayout)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=ClassicLayout()).run()


