#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
import __builtin__
from os.path import getmtime, exists
import time
import types
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import *
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from prewikka import utils

##################################################
## MODULE CONSTANTS
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.4.1'
__CHEETAH_versionTuple__ = (2, 4, 1, 'final', 0)
__CHEETAH_genTime__ = 1438954269.1347051
__CHEETAH_genTimestamp__ = 'Fri Aug  7 15:31:09 2015'
__CHEETAH_src__ = 'prewikka/views/filter/templates/FilterEdition.tmpl'
__CHEETAH_srcLastModified__ = 'Fri Aug  7 15:31:02 2015'
__CHEETAH_docstring__ = 'Autogenerated by Cheetah: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class FilterEdition(Template):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        super(FilterEdition, self).__init__(*args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def respond(self, trans=None):



        ## CHEETAH: main method generated for this template
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write(u'''
<script type="text/javascript"><!--

''')
        if VFFSL(SL,"fltr.type",True): # generated from line 5, col 1
            ftype = VFFSL(SL,"fltr.type",True)
        else: # generated from line 7, col 1
            ftype = "alert"
        write(u"""
var current_type = '""")
        _v = VFFSL(SL,"ftype",True) # u'$ftype' on line 11, col 21
        if _v is not None: write(_filter(_v, rawExpr=u'$ftype')) # from line 11, col 21.
        write(u'''\'

function resetFilterType(type)
{
    current_type = type

    tbody = document.getElementById("elements")

    while ( tbody.hasChildNodes() && tbody.lastChild != tbody ) {
        tbody.removeChild(tbody.lastChild);
     }

    newFilterElement(\'A\', \'\', \'\', \'\')
}



function newFilterElement(name, object, operator, object_value) {
    if ( current_type == \'alert\' ) {
        objects = new Array(''')
        _v = VFFSL(SL,"alert_objects",True) # u'$alert_objects' on line 30, col 29
        if _v is not None: write(_filter(_v, rawExpr=u'$alert_objects')) # from line 30, col 29.
        write(u''')
    } else {
        objects = new Array(''')
        _v = VFFSL(SL,"generic_objects",True) # u'$generic_objects' on line 32, col 29
        if _v is not None: write(_filter(_v, rawExpr=u'$generic_objects')) # from line 32, col 29.
        write(u''')
    }

    operators = new Array(''')
        _v = VFFSL(SL,"operators",True) # u'$operators' on line 35, col 27
        if _v is not None: write(_filter(_v, rawExpr=u'$operators')) # from line 35, col 27.
        write(u''')

    table = document.getElementById("elements")

    if ( ! name ) {
        if ( table.lastChild.nodeName == "TR" ) {
            child = table.lastChild.firstChild.firstChild
            name = new String(child.nodeValue)
            if ( name.charAt(name.length - 1) == "Z" ) {
                name = name.concat("A")
            } else {
                name = name.substr(0, name.length - 1) +
                           String.fromCharCode(name.charCodeAt(name.length - 1) + 1)
            }
        } else {
            name = "A"
        }
    }

    row = document.createElement("tr")
    table.appendChild(row)

    field = document.createElement("td")
    row.appendChild(field)
    value = document.createTextNode(name)
    field.appendChild(value)

    field = document.createElement("td")
    row.appendChild(field)
    select = document.createElement("select")
    field.appendChild(select)
    select.setAttribute("name", "object_" + name)
    select.setAttribute("style", "width: 250px;")
    for ( var i = 0; i < objects.length; i++ ) {
        option = document.createElement("option")
        if ( object == objects[i] ) {
            option.setAttribute("selected", "true")
        }
        option.setAttribute("value", objects[i])
        select.appendChild(option)
        value = document.createTextNode(objects[i])
        option.appendChild(value)
    }

    field = document.createElement("td")
    row.appendChild(field)
    select = document.createElement("select")
    field.appendChild(select)
    select.setAttribute("name", "operator_" + name)
    for ( var i = 0; i < operators.length; i++ ) {
        /* NB: setting selected to true before adding option to select is mandatory,
                   if it is done after, it won\'t work  */
        option = document.createElement("option")
        if ( operator == operators[i] ) {
            option.setAttribute("selected", "true")
        }
        select.appendChild(option)
        option.setAttribute("value", operators[i])
        value = document.createTextNode(operators[i])
        option.appendChild(value)
    }

    field = document.createElement("td")
    row.appendChild(field)
    input = document.createElement("input")
    field.appendChild(input)
    /* NB: if type=text is set before value=something, the value won\'t be displayed */
    /*input.setAttribute("type", "text")*/
    input.setAttribute("name", "value_" + name)
    input.setAttribute("value", object_value)

    field = document.createElement("td")
    row.appendChild(field)
    link = document.createElement("a")
    link.setAttribute("href", "#")
    field.appendChild(link)
    link.onclick = function() { this.parentNode.parentNode.parentNode.removeChild(this.parentNode.parentNode); return false; }
    link.setAttribute("style", "position: relative; float: right;")
    value = document.createTextNode("-")
    link.appendChild(value)
}

$(document).ready(function() {

  $("input[value=filter]").click(function() {
        $(".fieldset_heading legend").text("''')
        if False:
            _("Available filters")
        _v = VFFSL(SL,"_",False)("Available filters") # u'$_("Available filters")' on line 120, col 46
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Available filters")')) # from line 120, col 46.
        write(u'''");
        $("#curtype").prop("value", "filter")
        $(".filter_only").show();
  });

  $("input[value=filter]").trigger("click");
});

//--></script>


''')
        _orig_filter_33043422 = _filter
        filterName = u'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write(u'''
<div id="fieldset_page" style="max-width:500px;">

<form action="''')
        _v = VFFSL(SL,"document.href",True) # u'$document.href' on line 135, col 15
        if _v is not None: write(_filter(_v, rawExpr=u'$document.href')) # from line 135, col 15.
        write(u'''" method="post">

<fieldset class="fieldset_heading" style="display: table-cell;">
<legend>''')
        if False:
            _("Available filters")
        _v = VFFSL(SL,"_",False)("Available filters") # u'$_("Available filters")' on line 138, col 9
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Available filters")')) # from line 138, col 9.
        write(u'''</legend>
  <select class="filter_only" style="width: 70%;" name="filter_name">
    <option value="">&nbsp;</option>
''')
        for f in VFFSL(SL,"filters",True): # generated from line 141, col 3
            if VFFSL(SL,"f",True) == VFFSL(SL,"fltr.name",True): # generated from line 142, col 5
                selected = "selected=\"selected\""
            else: # generated from line 144, col 5
                selected = ""
            write(u'''    <option value="''')
            _v = VFFSL(SL,"f",True) # u'$f' on line 147, col 20
            if _v is not None: write(_filter(_v, rawExpr=u'$f')) # from line 147, col 20.
            write(u'''" ''')
            _v = VFFSL(SL,"selected",True) # u'$selected' on line 147, col 24
            if _v is not None: write(_filter(_v, rawExpr=u'$selected')) # from line 147, col 24.
            write(u'''>''')
            _v = VFFSL(SL,"f",True) # u'$f' on line 147, col 34
            if _v is not None: write(_filter(_v, rawExpr=u'$f')) # from line 147, col 34.
            write(u'''</option>
''')
        write(u'''  </select>

  <input type="submit" name="mode" value="''')
        if False:
            _("Load")
        _v = VFFSL(SL,"_",False)("Load") # u'$_("Load")' on line 151, col 43
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Load")')) # from line 151, col 43.
        write(u'''"/>
  <input type="submit" name="mode" value="''')
        if False:
            _("Delete")
        _v = VFFSL(SL,"_",False)("Delete") # u'$_("Delete")' on line 152, col 43
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Delete")')) # from line 152, col 43.
        write(u'''"/>
</fieldset>

</form>

<br/>

<form action="''')
        _v = VFFSL(SL,"document.href",True) # u'$document.href' on line 159, col 15
        if _v is not None: write(_filter(_v, rawExpr=u'$document.href')) # from line 159, col 15.
        write(u'''" method="post">

<fieldset>
<legend>''')
        if False:
            _("Add / Modify")
        _v = VFFSL(SL,"_",False)("Add / Modify") # u'$_("Add / Modify")' on line 162, col 9
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Add / Modify")')) # from line 162, col 9.
        write(u'''</legend>
''')
        alert_default = ""
        heartbeat_default = ""
        generic_default = ""
        write(u'''
''')
        if VFFSL(SL,"fltr.type",True) == "alert": # generated from line 167, col 1
            alert_default = "selected=\"selected\""
        write(u'''
''')
        if VFFSL(SL,"fltr.type",True) == "heartbeat": # generated from line 171, col 1
            heartbeat_default = "selected=\"true\""
        write(u'''
''')
        if VFFSL(SL,"fltr.type",True) == "generic": # generated from line 175, col 1
            generic_default = "selected=\"true\""
        write(u'''

<div class="filter_only">
<p>
 <i>''')
        if False:
            _("filter_intro")
        _v = VFFSL(SL,"_",False)("filter_intro") # u'$_("filter_intro")' on line 182, col 5
        if _v is not None: write(_filter(_v, rawExpr=u'$_("filter_intro")')) # from line 182, col 5.
        write(u'''</i>
</p>
<p>
 <i>''')
        if False:
            _("filter_advice")
        _v = VFFSL(SL,"_",False)("filter_advice") # u'$_("filter_advice")' on line 185, col 5
        if _v is not None: write(_filter(_v, rawExpr=u'$_("filter_advice")')) # from line 185, col 5.
        write(u'''</i>
</p>
</div>

<br />

<table class="filter_only">
<tr class="nodash">
 <th class="nodash">''')
        if False:
            _("Filter Type:")
        _v = VFFSL(SL,"_",False)("Filter Type:") # u'$_("Filter Type:")' on line 193, col 21
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Filter Type:")')) # from line 193, col 21.
        write(u'''</th>
 <td class="nodash">

  <select name="filter_type" style="width: 400px;" onchange="javascript:resetFilterType(this.options[this.selectedIndex].value);">
   <option ''')
        _v = VFFSL(SL,"alert_default",True) # u'$alert_default' on line 197, col 12
        if _v is not None: write(_filter(_v, rawExpr=u'$alert_default')) # from line 197, col 12.
        write(u''' value="alert">''')
        if False:
            _("Alert")
        _v = VFFSL(SL,"_",False)("Alert") # u'$_("Alert")' on line 197, col 41
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Alert")')) # from line 197, col 41.
        write(u'''</option>
   <option ''')
        _v = VFFSL(SL,"heartbeat_default",True) # u'$heartbeat_default' on line 198, col 12
        if _v is not None: write(_filter(_v, rawExpr=u'$heartbeat_default')) # from line 198, col 12.
        write(u''' value="heartbeat">''')
        if False:
            _("Heartbeat")
        _v = VFFSL(SL,"_",False)("Heartbeat") # u'$_("Heartbeat")' on line 198, col 49
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Heartbeat")')) # from line 198, col 49.
        write(u'''</option>
   <option ''')
        _v = VFFSL(SL,"generic_default",True) # u'$generic_default' on line 199, col 12
        if _v is not None: write(_filter(_v, rawExpr=u'$generic_default')) # from line 199, col 12.
        write(u''' value="generic">''')
        if False:
            _("Generic (Alert and Heartbeat)")
        _v = VFFSL(SL,"_",False)("Generic (Alert and Heartbeat)") # u'$_("Generic (Alert and Heartbeat)")' on line 199, col 45
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Generic (Alert and Heartbeat)")')) # from line 199, col 45.
        write(u'''</option>
  </select>

 </td>
</tr>
</table>

<hr class="filter_only" />

<table class="filter_only">
 <tfoot>
  <tr>
   <td style="text-align: right;" colspan="4">&nbsp;</td>
   <td><a style="text-align: right;" onclick="javascript:newFilterElement(\'\', \'\', \'\', \'\'); return false;">+</a></td>
  </tr>
 </tfoot>
 <tbody id="elements"></tbody>
</table>

''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_33043422
        _orig_filter_27944800 = _filter
        filterName = u'Filter'
        if self._CHEETAH__filters.has_key("Filter"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write(u'''
<script type="text/javascript"><!--
''')
        for element in VFFSL(SL,"elements",True): # generated from line 222, col 1
            write(u'''    newFilterElement("''')
            _v = VFN(VFFSL(SL,"utils",True),"escape_attribute",False)(VFFSL(SL,"element.name",True)) # u'$utils.escape_attribute($element.name)' on line 223, col 23
            if _v is not None: write(_filter(_v, rawExpr=u'$utils.escape_attribute($element.name)')) # from line 223, col 23.
            write(u'''", "''')
            _v = VFN(VFFSL(SL,"utils",True),"escape_attribute",False)(VFFSL(SL,"element.object",True)) # u'$utils.escape_attribute($element.object)' on line 223, col 65
            if _v is not None: write(_filter(_v, rawExpr=u'$utils.escape_attribute($element.object)')) # from line 223, col 65.
            write(u'''", "''')
            _v = VFN(VFFSL(SL,"utils",True),"escape_attribute",False)(VFFSL(SL,"element.operator",True)) # u'$utils.escape_attribute($element.operator)' on line 223, col 109
            if _v is not None: write(_filter(_v, rawExpr=u'$utils.escape_attribute($element.operator)')) # from line 223, col 109.
            write(u'''", "''')
            _v = VFN(VFFSL(SL,"utils",True),"escape_attribute",False)(VFFSL(SL,"element.value",True)) # u'$utils.escape_attribute($element.value)' on line 223, col 155
            if _v is not None: write(_filter(_v, rawExpr=u'$utils.escape_attribute($element.value)')) # from line 223, col 155.
            write(u'''");
''')
        write(u'''//--></script>

''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_27944800
        _orig_filter_48827531 = _filter
        filterName = u'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write(u'''
<br />

<table class="filter_only">
 <tr>
  <th>''')
        if False:
            _("Formula:")
        _v = VFFSL(SL,"_",False)("Formula:") # u'$_("Formula:")' on line 234, col 7
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Formula:")')) # from line 234, col 7.
        write(u'''</th>
  <td><input style="width: 400px;" type="text" name="filter_formula" value="''')
        _v = VFFSL(SL,"fltr.formula",True) # u'$fltr.formula' on line 235, col 77
        if _v is not None: write(_filter(_v, rawExpr=u'$fltr.formula')) # from line 235, col 77.
        write(u'''"/></td>
 </tr>
 <tr>
  <th>''')
        if False:
            _("Name:")
        _v = VFFSL(SL,"_",False)("Name:") # u'$_("Name:")' on line 238, col 7
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Name:")')) # from line 238, col 7.
        write(u'''</th>
  <td><input style="width: 400px;" type="text" name="filter_name" value="''')
        _v = VFFSL(SL,"fltr.name",True) # u'$fltr.name' on line 239, col 74
        if _v is not None: write(_filter(_v, rawExpr=u'$fltr.name')) # from line 239, col 74.
        write(u'''"/></td>
 </tr>
 <tr>
  <th style="vertical-align: top;">''')
        if False:
            _("Comment:")
        _v = VFFSL(SL,"_",False)("Comment:") # u'$_("Comment:")' on line 242, col 36
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Comment:")')) # from line 242, col 36.
        write(u'''</th>
  <td><textarea style="width: 400px;" name="filter_comment" rows="4" cols="55">''')
        _v = VFFSL(SL,"fltr.comment",True) # u'$fltr.comment' on line 243, col 80
        if _v is not None: write(_filter(_v, rawExpr=u'$fltr.comment')) # from line 243, col 80.
        write(u'''</textarea></td>
 </tr>
</table>

<input style="float: right;" type="submit" name="mode" value="''')
        if False:
            _("Save")
        _v = VFFSL(SL,"_",False)("Save") # u'$_("Save")' on line 247, col 63
        if _v is not None: write(_filter(_v, rawExpr=u'$_("Save")')) # from line 247, col 63.
        write(u'''"/>
</fieldset>
</form>

</div>
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_48827531
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_FilterEdition= 'respond'

## END CLASS DEFINITION

if not hasattr(FilterEdition, '_initCheetahAttributes'):
    templateAPIClass = getattr(FilterEdition, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(FilterEdition)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=FilterEdition()).run()


